C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     KSM_WRITESYMM    **
C**************************
C
CD-Routine: Write Symmetry Data Keyword Data - KSM_WRITESYMM
C This routine writes out the symmetry keyword data to a file or a terminal.
CD-end
CD-Fortran:
      SUBROUTINE KSM_WRITESYMM (IUN, TERM)
CD-end
C
C Purpose: List symmetry information
C
C Author:  John W. Campbell, July 1995 (from LDM_SYMM_LIST)
C
C Arguments:
C
      INTEGER IUN
      LOGICAL TERM
C
CD-Parameters:     
C  IUN   i (R)   Unit no. for listing o/p
C  TERM  l (R)   .TRUE. o/p is to a terminal; .FALSE. o/p is to a file
CD-end
C
C====== GLOBALS:
C
      INCLUDE 'ksm_data.finc'
C
C====== FUNCTION TYPES:
C
      INTEGER LENSTR
C
C====== LOCALS:
C
      CHARACTER*120 STR
      INTEGER I
C
C-------------------------------------------------------------------------------
C
      IF (NSYM.EQ.0) THEN
         STR = 'SYMMETRY'
         IF (TERM) THEN
            CALL TTSEND (IUN,STR(1:LENSTR(STR)),1)
         ELSE
            WRITE(IUN,1000) STR(1:LENSTR(STR))
         END IF
         RETURN
      END IF

      IF (NSPGRP.GT.0.OR.SPGNAM.NE.' ') THEN
         STR = 'SYMMETRY'
         IF (NSPGRP.GT.0) THEN
            CALL STR_ADDI (STR, NSPGRP, 1)
         ELSE
            CALL STR_ADDS (STR, SPGNAM, 1)
         END IF
         IF (TERM) THEN
            CALL TTSEND (IUN,STR(1:LENSTR(STR)),1)
         ELSE
            WRITE(IUN,1000) STR(1:LENSTR(STR))
         END IF
      ELSE
         IF (NSYM.GT.0) THEN
            DO 10 I = 1, NSYM
               STR = 'SYMMETRY'
               CALL KSM_SYMM_STR (I, STR(10:))
               IF (TERM) THEN
                  CALL TTSEND (IUN,STR(1:LENSTR(STR)),1)
               ELSE
                  WRITE(IUN,1000) STR(1:LENSTR(STR))
               END IF
10          CONTINUE
         END IF
      END IF
C
C====== Format statements
C
1000  FORMAT (A)
      END
