
C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C***********************
C**     RPF_FRACS     **
C***********************
C
CD-Routine: Get spot fractions - RPF_FRACS
C This routine may be called by the user supplied output subroutine for the
C rpf_predict subroutine to access the spot fraction parameters calculated
C for the reflection for which the output routine has been called.
CD-end
CD-Fortran:
      SUBROUTINE RPF_FRACS (DEL_EPS1, DEL_EPS2, D_RATIO)
CD-end
C
C PURPOSE: Returns spot fractions parameters from previous call to RPF_DSTAR
C
C AUTHOR:  John W. Campbell, May 1995
C
C ARGUMENTS:
C
      REAL DEL_EPS1
      REAL DEL_EPS2
      REAL D_RATIO
CD-Parameters:
C DEL_EPS1  (W)  Fraction of spot remaining to pass through Ewald
C                sphere at start of oscillation.
C DEL_EPS2  (W)  Fraction of spot that has already passed through
C                Ewald sphere at end of oscillation.
C D_RATIO   (W)  Fraction recorded for rejection criterion >=1.0 for fully's, 
C                the larger the safer.
CD-end
C====== Parameter statements
C 

C
C====== GLOBALS:
C

      REAL DELEPS1
      REAL DELEPS2
      REAL DRATIO
      COMMON /RPF_DSTAR_XX/ DELEPS1, DELEPS2, DRATIO
      SAVE /RPF_DSTAR_XX/
C
C====== FUNCTION TYPES:
C

C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      DEL_EPS1 = DELEPS1
      DEL_EPS2 = DELEPS2
      D_RATIO = DRATIO
      RETURN
      END
