
C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     RPF_LIM          **
C**************************
C
C
      SUBROUTINE RPF_LIM(LMIN, LMAX, LB, LE, IER)
C
C
C PURPOSE: Checks whether index is outside limit.
C          Used in REEKE algorithm - called by RPF_PREDICT
C
C AUTHOR:  From MADNES - PRDLIM
C
C *** SERVICE ROUTINE ONLY ***
C
C ARGUMENTS:
C
      INTEGER LMIN
      INTEGER LMAX
      INTEGER LB
      INTEGER LE
      INTEGER IER
C
C LMIN     (R)    Minimum index
C LMAX     (R)    Maximum index
C LB       (R/W)  Index at beginning (reset to LMIN if < LMIN)
C LE       (R/W)  Index at end (reset to LMAX if > LMAX)
C IER      (W)    Error flag =0 OK, non-zero - limits are bad
C
C====== Parameter statements
C 

C
C====== GLOBALS:
C

C
C====== FUNCTION TYPES:
C

C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      IER = 1
      IF ( (LB .LE. LMAX) .AND. (LE .GE. LMIN) ) THEN
         LB = MAX0(LB, LMIN)
         LE = MIN0(LE, LMAX)
         IER = 0
      ENDIF
      RETURN
      END
