
C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     RPF_QD2          **
C**************************
C
C
      SUBROUTINE RPF_QD2 (A, B, C, V, NR)
C
C
C PURPOSE:  Used in REEKE algorithm - called by RPF_PREDICT
C           Solves for V in quadratic of form: A*V**2 + 2*B*V + C = 0
C
C AUTHOR:  From MADNES - PRDQD2
C
C *** SERVICE ROUTINE ONLY ***
C
C ARGUMENTS:
C
      REAL A
      REAL B
      REAL C
      REAL V(2)
      INTEGER NR
C
C A       (R) 'A' coefficient of quadratic equation 
C B       (R) 'B' coefficient of quadratic equation 
C C       (R) 'C' coefficient of quadratic equation 
C V(2)    (W) Returns roots of the equation
C NR      (W) Returns number of roots found
C
C====== Parameter statements
C 

C
C====== GLOBALS:
C

C
C====== FUNCTION TYPES:
C

C
C====== LOCALS:
C
      REAL D
C
C-------------------------------------------------------------------------------
C
C
      NR = 0
      IF (A .NE. 0.0) THEN
         D = B**2 -  A * C
         IF (D .EQ. 0.0) THEN
            NR = 1
            V(1) = -B / A
         ELSE IF (D .GT. 0.0) THEN
            NR = 2
            D = SQRT(D)
            V(1) = (-B + D)  /  A
            V(2) = (-B - D)  /  A
         ENDIF
      ELSE IF (B .NE. 0.0) THEN
C
C   Here if A = 0 and B not = 0
C
         NR = 1
         V(1) = -0.5 * C / B
      ENDIF
      RETURN
      END
