
C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C****************************
C**    RPF_SET_BMATRIX     **
C****************************
C
CD-Routine: Set up orthogonalisation matrix - RPF_SET_BMATRIX
C This routine sets up the standard  orthogonalisation or 'B'  matrix given
C the unit cell parameters and a wavelength.
CD-end
CD-Fortran:
      SUBROUTINE RPF_SET_BMATRIX (CELL, WAVE, BMAT)
CD-end
C
C Purpose: Set up 'B' (standard orthogonalisation) matrix
C
C Author:  John W. Campbell, June 1995
C
C Arguments:
C
      REAL CELL(6)
      REAL WAVE
      REAL BMAT(3,3)

CD-Parameters:
C CELL(6)    (R)   Real cell dimensions (Angstroms and degrees)
C WAVE       (R)   Wavelength (Angstroms)
C BMAT(3,3)  (W)   Returns the 'B' matrix
CD-end     
C
C====== Parameter statements
C 

C
C====== GLOBALS:
C

C
C====== FUNCTION TYPES:
C

C
C====== LOCALS:
C
      REAL R(6)
      REAL DTOR

      DATA DTOR/0.0174533/ 
C
C-------------------------------------------------------------------------------
C
      CALL RPF_RECCEL(R, CELL, WAVE)
      BMAT(1,1) = R(1)
      BMAT(1,2) = COS(R(6)*DTOR)*R(2)
      BMAT(1,3) = COS(R(5)*DTOR)*R(3)
      BMAT(2,1) = 0.0
      BMAT(2,2) = SIN(R(6)*DTOR)*R(2)
      BMAT(2,3) = -SIN(R(5)*DTOR)*R(3)*COS(CELL(4)*DTOR)
      BMAT(3,1) = 0.0
      BMAT(3,2) = 0.0
      BMAT(3,3) = WAVE/CELL(3)
      RETURN
      END
